@ECHO OFF
Title Testing Synfig...
:Start
cls
pushd .
cd ..
Set synfig_path=%CD%\bin
popd
Set script_path=%CD%
pushd .
cd ..
Set results_path=%CD%\results\rendering
popd
Set PATH=%PATH%;%synfig_path%
Set n=^> NUL 2^>^&1

Call :tests software
REM Call :tests gl
Call :tests safe
echo done.
pause
Exit

REM >>>=== PROCEDURES ===<<<
:test
        Set engine=%1
        Set test_name=%2
        Set test_script_path=%script_path%\%test_name%
        Set test_results_path=%results_path%\%test_name%\%engine%
        Set test_blank_path=%test_results_path%\blank

        echo.
        echo %engine% %test_name%:

        del /F /Q %test_results_path%\* %n%
        mkdir %test_blank_path% %n%
        copy %script_path%\common\*       %test_results_path% %n%
        copy %test_script_path%\*         %test_results_path% %n%
        copy %test_script_path%\common\*         %test_blank_path% %n%
        copy %test_script_path%\%engine%\*         %test_blank_path% %n%
        cd %test_results_path%

        Set SYNFIG_TARGET_DEFAULT_ENGINE=%engine%
        Set SYNFIG_RENDERING_THREADS=1
        Set SYNFIG_RENDERING_DEBUG_TASK_LIST_LOG=task_list.log
        Set SYNFIG_RENDERING_DEBUG_TASK_LIST_OPTIMIZED_LOG=optimized_task_list.log
        Set SYNFIG_RENDERING_DEBUG_RESULT_IMAGE=result.tga
        Call run.bat
        Set error=%ERRORLEVEL%

        if %error% EQU 0 (
                echo success
        ) else (
                echo FAILED!!!
        )

        cd %script_path%
Exit /b

:tests
        Call :test %1 01_simple
        Call :test %1 02_composite_layers
        Call :test %1 03_composite_group
        Call :test %1 04_optimizer_blend_zero
        Call :test %1 05_optimizer_blend_composite
        Call :test %1 06_optimizer_blend_split
        Call :test %1 07_optimizer_blend_composite_advanced
        Call :test %1 08_blend_methods
        Call :test %1 09_snowman
        Call :test %1 10_rapper
        Call :test %1 11_rapper_without_shadows
        Call :test %1 12_rapper_x8
        Call :test %1 13_translate_rotate_scale
        Call :test %1 14_images
        Call :test %1 15_images_heavy
        Call :test %1 16_old_layers
Exit /b
